#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileoutput.h"

/*

Anaglyph - Copyright 2004 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://ringtonetools.mikekohn.net/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* BMP */

int curr_x,total_x;

void write_bmp_header(FILE *out, int width, int height)
{
int image_width;

  image_width=width*3;
  while ((image_width%4)!=0) image_width++;
  total_x=width;

/* size: 14 bytes */

  write_chars(out,"BM");
  write_long(out,0);
  write_word(out,0);
  write_word(out,0);
  write_long(out,54);

/* head1: 14  head2: 40 */

  write_long(out,40);         /* biSize */
  write_long(out,width);
  write_long(out,height);
  write_word(out,1);
  write_word(out,24);
  write_long(out,0);          /* compression */
  write_long(out,image_width*height);
  write_long(out,0);          /* biXPelsperMetre */
  write_long(out,0);          /* biYPelsperMetre */
  write_long(out,0);
  write_long(out,0);

  curr_x=0;
}

void write_bmp_pixel(FILE *out, unsigned char left_value, unsigned char right_value)
{
  putc(right_value,out);
  putc(0,out);
  putc(left_value,out);

  total_x=total_x+3;

  if (curr_x==total_x)
  {
    curr_x=curr_x*3;
    while ((curr_x%4)!=0)
    {
      putc(0,out);
      curr_x++;
    }
    curr_x=0;
  }
}




